package de.gedoplan.beantrial.jboss7remoteejb;

import junit.framework.Assert;

import java.util.Properties;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.junit.Test;

public class UserInfoTest
{

  @Test
  public void testGetUserId_Anonymous() throws NamingException
  {
    testGetUserId("anonymous", "anonymousanonymous");
  }

  @Test
  public void testGetUserId_baselibsTestuser1() throws NamingException
  {
    testGetUserId("baselibsTestuser1", "pwd4baselibsTestuser1");
  }

  private void testGetUserId(String user, String pwd) throws NamingException
  {
    String lookupName = "jboss7remoteEjb/" + UserInfoBean.class.getSimpleName() + "!" + UserInfo.class.getName();
    UserInfo userInfo = (UserInfo) getInitialContext(user, pwd).lookup(lookupName);

    String ejbUser = userInfo.getUserId();

    Assert.assertEquals("Wrong user", user, ejbUser);
  }

  private Context getInitialContext(String user, String pwd) throws NamingException
  {
    Properties jndiProps = new Properties();

    jndiProps.put(Context.INITIAL_CONTEXT_FACTORY, "org.jboss.naming.remote.client.InitialContextFactory");
    jndiProps.put(Context.PROVIDER_URL, "remote://localhost:4447");

    jndiProps.setProperty(Context.SECURITY_PRINCIPAL, user);
    jndiProps.setProperty(Context.SECURITY_CREDENTIALS, pwd);

    jndiProps.put("jboss.naming.client.ejb.context", true);

    return new InitialContext(jndiProps);
  }
}
